'use strict';

// REQUIRE
var yeoman = require('yeoman-generator');
var chalk = require('chalk');
var yosay = require('yosay');
var mkdirp = require('mkdirp');
var MyBase = require('../myBase.js');

// COSTANTI

// VARIABILI
var self;


module.exports = MyBase.extend({
  initializing: initializing,
  prompting: prompting,
  writing: writing,
  install: install
});


function initializing(){
  self = this;
  self.sourceRoot(self.TEMPLATES_PATH);
}


function prompting() {
  self.log(yosay('Nextechs ' + chalk.red('angular app') + ' generator!'));
  var prompts = [self.PROMPTS.MODULE_NAME, self.PROMPTS.DESCRIPTION];
  return self.prompt(prompts).then(self.storeProps.bind(this));
}


function writing() {
  __copyProjectFiles();
  __copyAppFiles();
}


function __copyProjectFiles() {
  self.copyTpl(self.PREFIX + 'package.json', 'package.json');
  self.copyTpl(self.PREFIX + 'bower.json', 'bower.json');
  self.copy(self.PREFIX + '.yo-rc.json', '.yo-rc.json');
  self.copy(self.PREFIX + 'gruntfile.js', 'gruntfile.js');
  self.copy(self.PREFIX + 'index.html', 'index.html');
  self.copy(self.PREFIX + '.gitignore', '.gitignore');
  self.copy(self.PREFIX + 'readme.md', 'readme.md');
}


function __copyAppFiles() {

  var dir = 'app/';
  var name = self.props.moduleName;

  self.copyTpl(self.PREFIX + '.config.js', dir + name + '.config.js');
  self.copyTpl(self.PREFIX + '.module.js', dir + name + '.module.js');
  self.copyTpl(self.PREFIX + '.routes.app.js', dir + name + '.routes.js');
  self.copyTpl(self.PREFIX + '.run.js', dir + name + '.run.js');

  self.copy(self.PREFIX + 'dataFlowEngine.config.js', dir + 'dataFlowEngine.config.js');

  // creiamo le cartelle vuote
  mkdirp.sync(dir + 'constants/');
  mkdirp.sync(dir + 'directives/');
  mkdirp.sync(dir + 'filters/');
  mkdirp.sync(dir + 'services/');
}


function install() {
  // self.installDependencies();
}
