'use strict';

// REQUIRE
var yeoman = require('yeoman-generator');
var chalk = require('chalk');
var yosay = require('yosay');
var mkdirp = require('mkdirp');
var MyBase = require('../myBase.js');


// COSTANTI

// VARIABILI
var self;


module.exports = MyBase.extend({
  initializing: initializing,
  prompting: prompting,
  writing: writing
});


function initializing() {
  self = this;
  self.sourceRoot(self.TEMPLATES_PATH);
}


function prompting() {
  self.log(yosay('Nextechs ' + chalk.red('model services') + ' generator!'));
  var prompts = [self.PROMPTS.SERVICES, self.PROMPTS.MODULE_NAME, self.PROMPTS.PATH];
  return self.prompt(prompts).then(self.storeProps.bind(this));
}


function writing() {

  var services = self.props.services;
  var moduleName = self.props.moduleName;
  var dest = 'app/' + moduleName + '/';

  services.forEach(function(key, index){
    self.props.modelName = key;
    self.props.serviceName = moduleName + self.capitalize(self.MODEL_SERVICES[key]);
    var prefix = 'services/models/';
    self.copyTpl(self.PREFIX + '.model.service.js', dest + prefix + self.props.serviceName + '.service.js')
  });
}




