'use strict';

// REQUIRE
var yeoman = require('yeoman-generator');
var path = require('path');

// COSTANTI
var __MODEL_SERVICES = {
  account: 'account',
  agent: 'agent',
  appuser: 'appUser',
  disposalstrategy: 'disposalStrategy',
  disposalstrategyguide: 'disposalStrategyGuide',
  disposalstrategytype: 'disposalStrategyType',
  emassignment: 'emAssignment',
  emcalendareventmotivation: 'emCalendarEventMotivation',
  emcalendareventtype: 'emCalendarEventType',
  pickupdate: 'pickupDate',
  pickupreading: 'pickupReading',
  pickupreservation: 'pickupReservation',
  pickupservice: 'pickupService',
  role: 'role',
  service: 'service',
  serviceonarea: 'serviceOnArea',
  supervisor: 'supervisor',
  ticket: 'ticket',
  ticketoption: 'ticketOption',
  ticketstatus: 'ticketStatus',
  tickettype: 'ticketType',
  user: 'user',
  vehicle: 'vehicle',
  wasteinstance: 'wasteInstance',
  wastetype: 'wasteType',
  wmcontract: 'wmContract',
  wmContractor: 'wmContractor',
  wmemcalendarevent: 'wmEmCalendarEvent',
  wmemployee: 'wmEmployee',
  wmnews: 'wmNews',
  wmrole: 'wmRole'
};

var __PROMPT_MODULE_NAME = {
  type: 'input',
  name: 'moduleName',
  message: "Inserici il nome del modulo",
  default: "app",
  store: true
};

var __PROMPT_VIEW_NAME = {
  type: 'input',
  name: 'viewName',
  message: "Inserici il nome",
  default: "view",
  store: true
};

var __PROMPT_DESCRIPTION = {
  type: 'input',
  name: 'description',
  message: "Inserici la descrizione",
  default: ""
};

var __PROMPT_PATH = {
  type: 'input',
  name: 'path',
  message: "Inserici il path. Deve terminare con lo / ",
  default: "app/",
  store: true
};

var __PROMPT_SERVICES = {
  type: 'checkbox',
  name: 'services',
  message: "Seleziona i servizi da creare",
  choices: Object.keys(__MODEL_SERVICES),
  default: Object.keys(__MODEL_SERVICES)
};

var __PROMPTS = {
  MODULE_NAME: __PROMPT_MODULE_NAME,
  VIEW_NAME: __PROMPT_VIEW_NAME,
  DESCRIPTION: __PROMPT_DESCRIPTION,
  PATH: __PROMPT_PATH,
  SERVICES: __PROMPT_SERVICES
};


// Definizione della classe base
var MyBase = module.exports = yeoman.Base.extend({
  PREFIX: 'NX_',
  PLACEHOLDER: '$$$',
  TEMPLATES_PATH: path.join(__dirname, 'templates'),
  PROMPTS: __PROMPTS,
  MODEL_SERVICES: __MODEL_SERVICES,
  // Helpers
  copy: copy,
  copyTpl: copyTpl,
  storeProps: storeProps,
  capitalize: capitalize
});



function copy(from, to) {
  to = to || from;
  this.fs.copy(this.templatePath(from), this.destinationPath(to));
}


function copyTpl(from, to) {
  to = to || from;
  this.fs.copyTpl(this.templatePath(from), this.destinationPath(to), this.props);
}


function storeProps(props) {
  this.props = props;
}


function capitalize(string) {
  return string.charAt(0).toUpperCase() + string.slice(1);
}


