'use strict';

// REQUIRE
var yeoman = require('yeoman-generator');
var chalk = require('chalk');
var yosay = require('yosay');
var mkdirp = require('mkdirp');
var MyBase = require('../myBase.js');


// COSTANTI

// VARIABILI
var self;


module.exports = MyBase.extend({
  initializing: initializing,
  prompting: prompting,
  writing: writing
});


function initializing() {
  self = this;
  self.sourceRoot(self.TEMPLATES_PATH);
}


function prompting() {
  self.log(yosay('Nextechs ' + chalk.red('submodule') + ' generator!'));
  var prompts = [self.PROMPTS.MODULE_NAME, self.PROMPTS.DESCRIPTION, self.PROMPTS.SERVICES];
  return self.prompt(prompts).then(self.storeProps.bind(this));
}


function writing() {

  var services = self.props.services;
  var moduleName = self.props.moduleName;
  var dest = 'app/' + moduleName + '/';

  self.copy(self.PREFIX + '.gitignore', dest + '.gitignore');
  self.copy(self.PREFIX + 'readme.md', dest + 'readme.md');

  self.copyTpl(self.PREFIX + '.html', dest + moduleName + '.html');
  self.copyTpl(self.PREFIX + '.config.js', dest + moduleName + '.config.js');
  self.copyTpl(self.PREFIX + '.module.js', dest + moduleName + '.module.js');
  self.copyTpl(self.PREFIX + '.routes.submodule.js', dest + moduleName + '.routes.js');
  self.copyTpl(self.PREFIX + '.run.js', dest + moduleName + '.run.js');

  services.forEach(function(key, index){
    self.props.modelName = key;
    self.props.serviceName = moduleName + self.capitalize(self.MODEL_SERVICES[key]);
    var prefix = 'services/models/';
    self.copyTpl(self.PREFIX + '.model.service.js', dest + prefix + self.props.serviceName + '.service.js')
  });

  // creiamo le cartelle vuote
  mkdirp.sync(dest + 'constants/');
  mkdirp.sync(dest + 'directives/');
  mkdirp.sync(dest + 'filters/');
}




