'use strict';

// REQUIRE
var yeoman = require('yeoman-generator');
var chalk = require('chalk');
var yosay = require('yosay');
var MyBase = require('../myBase.js');

// COSTANTI

// VARIABILI
var self;


module.exports = MyBase.extend({
  initializing: initializing,
  prompting: prompting,
  writing: writing
});


function initializing(){
  self = this;
  self.sourceRoot(self.TEMPLATES_PATH);
}


function prompting() {
  self.log(yosay('Nextechs ' + chalk.red('view') + ' generator!'));
  var prompts = [self.PROMPTS.MODULE_NAME, self.PROMPTS.VIEW_NAME, self.PROMPTS.PATH];
  return self.prompt(prompts).then(self.storeProps.bind(this));
}


function writing() {

  var name = self.props.viewName;
  var path = self.props.path;

  self.copyTpl(self.PREFIX + '.html', path + name + '.html');
  self.copyTpl(self.PREFIX + '.controller.js', path + name + '.controller.js');

}

